/**
 * UGENE - Integrated Bioinformatics Tools.
 * Copyright (C) 2008-2016 UniPro <ugene@unipro.ru>
 * http://ugene.unipro.ru
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

#ifndef _U2_ALIGN_SEQUENCES_TO_ALIGNMENT_TASK_SETTINGS_H_
#define _U2_ALIGN_SEQUENCES_TO_ALIGNMENT_TASK_SETTINGS_H_

#include "AbstractAlignmentTask.h"

namespace U2 {

class U2ALGORITHM_EXPORT AlignSequencesToAlignmentTaskSettings : public AbstractAlignmentTaskSettings {
public:
    AlignSequencesToAlignmentTaskSettings();
    AlignSequencesToAlignmentTaskSettings(const U2EntityRef& msaRef, const U2AlphabetId& newAlphabet, bool addAsFragments = false);
    AlignSequencesToAlignmentTaskSettings(const AlignSequencesToAlignmentTaskSettings &s);

    virtual bool isValid() const;

    QList<U2EntityRef> addedSequencesRefs;
    QStringList        addedSequencesNames;
    bool addAsFragments;
    bool reorderSequences;
    int referenceRowId;
    qint64 maxSequenceLength;
};
}   //namespace

#endif // _U2_PAIRWISE_ALIGNMENT_TASK_H_
