include (umuscle.pri)

# Input
HEADERS += src/MuscleAdapter.h \
           src/MuscleAlignDialogController.h \
           src/MuscleConstants.h \
           src/MuscleParallel.h \
           src/MusclePlugin.h \
           src/MuscleTask.h \
           src/MuscleUtils.h \
           src/MuscleWorker.h \
           src/MuscleWorkPool.h \
           src/ProfileToProfileWorker.h \
           src/TaskLocalStorage.h \
           src/muscle/alpha.h \
           src/muscle/clust.h \
           src/muscle/cluster.h \
           src/muscle/clustset.h \
           src/muscle/clustsetdf.h \
           src/muscle/clustsetmsa.h \
           src/muscle/diaglist.h \
           src/muscle/distcalc.h \
           src/muscle/distfunc.h \
           src/muscle/dpregionlist.h \
           src/muscle/dpreglist.h \
           src/muscle/edgelist.h \
           src/muscle/enumopts.h \
           src/muscle/enums.h \
           src/muscle/estring.h \
           src/muscle/gapscoredimer.h \
           src/muscle/gonnet.h \
           src/muscle/intmath.h \
           src/muscle/msa.h \
           src/muscle/msadist.h \
           src/muscle/msadistkimura.h \
           src/muscle/msadistmafft.h \
           src/muscle/muscle.h \
           src/muscle/muscle_context.h \
           src/muscle/objscore.h \
           src/muscle/params.h \
           src/muscle/profile.h \
           src/muscle/pwpath.h \
           src/muscle/scorehistory.h \
           src/muscle/seq.h \
           src/muscle/seqvect.h \
           src/muscle/textfile.h \
           src/muscle/timing.h \
           src/muscle/tree.h \
           src/muscle/types.h \
           src/muscle/unixio.h \
           src/umuscle_tests/umuscleTests.h
FORMS += src/MuscleAlignDialog.ui
SOURCES += src/MuscleAdapter.cpp \
           src/MuscleAlignDialogController.cpp \
           src/MuscleParallel.cpp \
           src/MusclePlugin.cpp \
           src/MuscleTask.cpp \
           src/MuscleUtils.cpp \
           src/MuscleWorker.cpp \
           src/MuscleWorkPool.cpp \
           src/ProfileToProfileWorker.cpp \
           src/refinehorizP.cpp \
           src/refinevertP.cpp \
           src/TaskLocalStorage.cpp \
           src/muscle/aligngivenpath.cpp \
           src/muscle/aligngivenpathsw.cpp \
           src/muscle/aligntwomsas.cpp \
           src/muscle/aligntwoprofs.cpp \
           src/muscle/aln.cpp \
           src/muscle/alpha.cpp \
           src/muscle/anchors.cpp \
           src/muscle/bittraceback.cpp \
           src/muscle/blosum62.cpp \
           src/muscle/blosumla.cpp \
           src/muscle/clust.cpp \
           src/muscle/cluster.cpp \
           src/muscle/clwwt.cpp \
           src/muscle/color.cpp \
           src/muscle/cons.cpp \
           src/muscle/diaglist.cpp \
           src/muscle/diffobjscore.cpp \
           src/muscle/diffpaths.cpp \
           src/muscle/difftrees.cpp \
           src/muscle/difftreese.cpp \
           src/muscle/distcalc.cpp \
           src/muscle/distfunc.cpp \
           src/muscle/distpwkimura.cpp \
           src/muscle/domuscle.cpp \
           src/muscle/dosp.cpp \
           src/muscle/dpreglist.cpp \
           src/muscle/drawtree.cpp \
           src/muscle/edgelist.cpp \
           src/muscle/enumopts.cpp \
           src/muscle/enumtostr.cpp \
           src/muscle/estring.cpp \
           src/muscle/fasta.cpp \
           src/muscle/fasta2.cpp \
           src/muscle/fastclust.cpp \
           src/muscle/fastdist.cpp \
           src/muscle/fastdistjones.cpp \
           src/muscle/fastdistkbit.cpp \
           src/muscle/fastdistkmer.cpp \
           src/muscle/fastdistmafft.cpp \
           src/muscle/fastdistnuc.cpp \
           src/muscle/fastscorepath2.cpp \
           src/muscle/finddiags.cpp \
           src/muscle/finddiagsn.cpp \
           src/muscle/glbalign.cpp \
           src/muscle/glbalign352.cpp \
           src/muscle/glbaligndiag.cpp \
           src/muscle/glbalignle.cpp \
           src/muscle/glbalignsimple.cpp \
           src/muscle/glbalignsp.cpp \
           src/muscle/glbalignspn.cpp \
           src/muscle/glbalignss.cpp \
           src/muscle/glbalndimer.cpp \
           src/muscle/globals.cpp \
           src/muscle/globalslinux.cpp \
           src/muscle/globalsosx.cpp \
           src/muscle/globalsother.cpp \
           src/muscle/globalswin32.cpp \
           src/muscle/gonnet.cpp \
           src/muscle/henikoffweight.cpp \
           src/muscle/henikoffweightpb.cpp \
           src/muscle/html.cpp \
           src/muscle/hydro.cpp \
           src/muscle/intmath.cpp \
           src/muscle/local.cpp \
           src/muscle/main.cpp \
           src/muscle/makerootmsa.cpp \
           src/muscle/makerootmsab.cpp \
           src/muscle/maketree.cpp \
           src/muscle/mhack.cpp \
           src/muscle/mpam200.cpp \
           src/muscle/msa.cpp \
           src/muscle/msa2.cpp \
           src/muscle/msadistkimura.cpp \
           src/muscle/msf.cpp \
           src/muscle/muscle.cpp \
           src/muscle/muscle_context.cpp \
           src/muscle/muscleout.cpp \
           src/muscle/nucmx.cpp \
           src/muscle/nwdasimple.cpp \
           src/muscle/nwdasimple2.cpp \
           src/muscle/nwdasmall.cpp \
           src/muscle/nwrec.cpp \
           src/muscle/nwsmall.cpp \
           src/muscle/objscore.cpp \
           src/muscle/objscore2.cpp \
           src/muscle/objscoreda.cpp \
           src/muscle/onexception.cpp \
           src/muscle/options.cpp \
           src/muscle/outweights.cpp \
           src/muscle/pam200mafft.cpp \
           src/muscle/params.cpp \
           src/muscle/phy.cpp \
           src/muscle/phy2.cpp \
           src/muscle/phy3.cpp \
           src/muscle/phy4.cpp \
           src/muscle/phyfromclust.cpp \
           src/muscle/phyfromfile.cpp \
           src/muscle/physeq.cpp \
           src/muscle/phytofile.cpp \
           src/muscle/posgap.cpp \
           src/muscle/ppscore.cpp \
           src/muscle/profdb.cpp \
           src/muscle/profile.cpp \
           src/muscle/profilefrommsa.cpp \
           src/muscle/progalign.cpp \
           src/muscle/progress.cpp \
           src/muscle/progressivealign.cpp \
           src/muscle/pwpath.cpp \
           src/muscle/readmx.cpp \
           src/muscle/realigndiffs.cpp \
           src/muscle/realigndiffse.cpp \
           src/muscle/refine.cpp \
           src/muscle/refinehoriz.cpp \
           src/muscle/refinesubfams.cpp \
           src/muscle/refinetree.cpp \
           src/muscle/refinetreee.cpp \
           src/muscle/refinevert.cpp \
           src/muscle/refinew.cpp \
           src/muscle/savebest.cpp \
           src/muscle/scoredist.cpp \
           src/muscle/scoregaps.cpp \
           src/muscle/scorehistory.cpp \
           src/muscle/scorepp.cpp \
           src/muscle/seq.cpp \
           src/muscle/seqvect.cpp \
           src/muscle/setblosumweights.cpp \
           src/muscle/setgscweights.cpp \
           src/muscle/setnewhandler.cpp \
           src/muscle/spfast.cpp \
           src/muscle/sptest.cpp \
           src/muscle/stabilize.cpp \
           src/muscle/subfam.cpp \
           src/muscle/subfams.cpp \
           src/muscle/sw.cpp \
           src/muscle/termgaps.cpp \
           src/muscle/textfile.cpp \
           src/muscle/threewaywt.cpp \
           src/muscle/tomhydro.cpp \
           src/muscle/traceback.cpp \
           src/muscle/tracebackopt.cpp \
           src/muscle/tracebacksw.cpp \
           src/muscle/treefrommsa.cpp \
           src/muscle/typetostr.cpp \
           src/muscle/upgma2.cpp \
           src/muscle/usage.cpp \
           src/muscle/validateids.cpp \
           src/muscle/vtml2.cpp \
           src/muscle/writescorefile.cpp \
           src/umuscle_tests/umuscleTests.cpp
RESOURCES += umuscle.qrc
TRANSLATIONS += transl/english.ts transl/russian.ts
